<script lang="ts" setup>
import { IGame } from '~/models/game/game.type';
import VueApexChart from 'vue3-apexcharts'
import { chartOptions } from './config';
import { useGames } from '~/composable/game';

const { sortedAllGame } = await useGames()

const series = computed(() => {
  const myEloData = sortedAllGame.value?.map(x => ({
    y: x.my_rate,
    x: x.date.toDate()
  }))
  const myEloSerie = {
    name: 'Mon classement',
    type: 'line',
    data: myEloData
  }
  const wons = sortedAllGame.value?.map(x => ({
    y: x.result === 1 ? x.opponent_rating : null,
    x: x.date.toDate()
  }))
  const wonSerie = {
    name: 'Victoire',
    type: 'scatter',
    data: wons
  }
  const draws = sortedAllGame.value?.map(x => ({
    y: x.result === 0 ? x.opponent_rating : null,
    x: x.date.toDate()
  }))
  const drawSerie = {
    name: 'Match nul',
    type: 'scatter',
    data: draws
  }
  const losses = sortedAllGame.value?.map(x => ({
    y: x.result === -1 ? x.opponent_rating : null,
    x: x.date.toDate()
  }))
  const lossesSerie = {
    name: 'Défaite',
    type: 'scatter',
    data: losses
  }
  return [myEloSerie, wonSerie, drawSerie, lossesSerie]
})

const chartRef = ref()


const router = useRouter()
const handleMarkerClick = (a: any, b: any, data: any) => {
  if (!sortedAllGame.value) return
  const game: IGame = sortedAllGame.value[data.dataPointIndex]

  if (game) {
    router.push(game.path)
  }

}
</script>

<template>
  <div>
    <ClientOnly>
      <VueApexChart 
      ref="chartRef" :options="chartOptions" type="line" :series="series" @markerClick="handleMarkerClick">
      </VueApexChart>
    </ClientOnly>
  </div>
</template>

<style lang="scss" scoped></style>